package kick.views;

import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.UIManager;
import java.awt.Font;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JButton;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.JDesktopPane;
import java.awt.SystemColor;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JRadioButton;
import javax.swing.ButtonGroup;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;

public class Main extends JFrame {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JPanel contentPane;
	private JDesktopPane desktopPane;
	private JButton btnSectionAnalysis;	
	JButton btnCalculate;
	private JPanel panelOutput;
	private final ButtonGroup buttonGroup = new ButtonGroup();
	private Section1 try1;
	private Section1_US try1_US;
	private Section2 try2;
	private Section2_US try2_US;
	private Section3 try3;
	private Section3_US try3_US;
	JRadioButton rButtonKick;
	JRadioButton rButtonMud;
	JRadioButton rButtonDepth;
	private JPanel panelCompute;
	int u,n;
	private Notificacions msj1;
	JPanel Panel1;
	private JPanel panelUnits;
	private JButton btnCompute;
	private JButton btnNewButton;
	private JPanel panel;

	

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (Throwable e) {
			e.printStackTrace();
		}
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main frame = new Main();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public Main() {
		setAlwaysOnTop(true);
		setResizable(false);
		initComponents();
		createEvents();
		
	}
	
	private void initComponents(){
		setFont(new Font("Dialog", Font.BOLD, 14));
		setTitle("Kick Tolerance Calculator");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(0, 0, 1280, 725);

		 
	     
		JMenuBar menuBar = new JMenuBar();
		setJMenuBar(menuBar);
		JMenu mnFile = new JMenu("File");
		menuBar.add(mnFile);
		
		JMenuItem mntmNew = new JMenuItem("New");
		mnFile.add(mntmNew);
		
		JMenuItem mntmOpen = new JMenuItem("Open");
		mnFile.add(mntmOpen);
		
		JMenuItem mntmSave = new JMenuItem("Save");
		mnFile.add(mntmSave);
		
		JMenuItem mntmExit = new JMenuItem("Exit");
		mntmExit.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				dispose();
			}
		});
		mnFile.add(mntmExit);
		
		JMenu mnEdit = new JMenu("Edit");
		menuBar.add(mnEdit);
		
		JMenu mnHelp = new JMenu("Help");
		menuBar.add(mnHelp);
		
		JMenuItem mntmHelp = new JMenuItem("Help");
		mnHelp.add(mntmHelp);
		
		JMenuItem mntmTutorial = new JMenuItem("Tutorial");
		mnHelp.add(mntmTutorial);
		
		JMenuItem mntmAbout = new JMenuItem("About this");
		mnHelp.add(mntmAbout);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		
		JPanel panelOptions = new JPanel();
		
		panelUnits = new JPanel();
		
		desktopPane = new JDesktopPane();
		desktopPane.setBackground(SystemColor.inactiveCaption);
		
		panelOutput = new JPanel();
		panelOutput.setBackground(UIManager.getColor("CheckBox.background"));
		
		panelCompute = new JPanel();
		GroupLayout gl_contentPane = new GroupLayout(contentPane);
		gl_contentPane.setHorizontalGroup(
			gl_contentPane.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_contentPane.createSequentialGroup()
					.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_contentPane.createSequentialGroup()
							.addComponent(panelOptions, GroupLayout.PREFERRED_SIZE, 339, GroupLayout.PREFERRED_SIZE)
							.addPreferredGap(ComponentPlacement.RELATED)
							.addComponent(panelUnits, GroupLayout.PREFERRED_SIZE, 163, GroupLayout.PREFERRED_SIZE)
							.addPreferredGap(ComponentPlacement.RELATED)
							.addComponent(panelOutput, GroupLayout.PREFERRED_SIZE, 479, GroupLayout.PREFERRED_SIZE)
							.addPreferredGap(ComponentPlacement.RELATED)
							.addComponent(panelCompute, GroupLayout.DEFAULT_SIZE, 215, Short.MAX_VALUE))
						.addComponent(desktopPane, GroupLayout.DEFAULT_SIZE, 1264, Short.MAX_VALUE))
					.addContainerGap())
		);
		gl_contentPane.setVerticalGroup(
			gl_contentPane.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_contentPane.createSequentialGroup()
					.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
						.addComponent(panelOptions, GroupLayout.DEFAULT_SIZE, 61, Short.MAX_VALUE)
						.addComponent(panelUnits, 0, 0, Short.MAX_VALUE)
						.addComponent(panelOutput, GroupLayout.DEFAULT_SIZE, 61, Short.MAX_VALUE)
						.addComponent(panelCompute, GroupLayout.DEFAULT_SIZE, 61, Short.MAX_VALUE))
					.addPreferredGap(ComponentPlacement.RELATED)
					.addComponent(desktopPane, GroupLayout.DEFAULT_SIZE, 592, Short.MAX_VALUE)
					.addContainerGap())
		);
		desktopPane.setLayout(null);
		
		String[] units={"Metric","US"};
		final JComboBox cBoxUnits =new JComboBox(units);
		

		btnNewButton = new JButton("Extra Info");
		desktopPane.setLayer(btnNewButton, 3);
		btnNewButton.setVisible(false);
		
		btnNewButton.setFont(new Font("Lucida Grande", Font.BOLD, 14));
		btnNewButton.setBounds(812, 31, 128, 52);
		desktopPane.add(btnNewButton);
		
		panel = new JPanel();
		desktopPane.setLayer(panel, 3);
		panel.setBounds(774, 31, 460, 547);
		desktopPane.add(panel);
		panel.setVisible(false);
		
		
		cBoxUnits.setSelectedIndex(0);
		
		final JRadioButton rButtonKick = new JRadioButton("Kick Tolerance");
		
		
		final JRadioButton rButtonMud = new JRadioButton("Mud Weight");
		rButtonMud.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent evt) {
				
			}
		});
		
		final JRadioButton rButtonDepth = new JRadioButton("Open Hole Depth");
		rButtonDepth.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent evt) {
				
			}
		});
		
		
		JButton btnForm = new JButton("New Form");
		btnCompute = new JButton("COMPUTE");
		btnCompute.setVisible(false);
		btnForm.setToolTipText("");
		
		btnForm.addActionListener(new ActionListener() {
			
			public void actionPerformed(ActionEvent e) {
				btnNewButton.setVisible(false);
				try1= new Section1();
				try1_US=new Section1_US();
				try2= new Section2();
				try2_US=new Section2_US();
				try3= new Section3();
				try3_US=new Section3_US();
				
				u = cBoxUnits.getSelectedIndex();
				btnCompute.setVisible(true);
				panel.setVisible(true);
				if(rButtonKick.isSelected()== true)
				{
					if (u==0)
					{
					desktopPane.add(try1);
					try1.show();
					try1_US.hide();
					try2.hide();
					try2_US.hide();
					try3.hide();
					try3_US.hide();
					}
					if(u==1)
					{
					desktopPane.add(try1_US);
					try1.hide();
					try1_US.show();
					try2.hide();
					try2_US.hide();
					try3.hide();
					try3_US.hide();	
					}
				}
				else if(rButtonMud.isSelected()==true)
				{	if (u==0)
					{
					desktopPane.add(try2);
					try1.hide();
					try1_US.hide();
					try2.show();
					try2_US.hide();
					try3.hide();
					try3_US.hide();
					}
					if(u==1)
					{
					desktopPane.add(try2_US);
					try1.hide();
					try1_US.hide();
					try2.hide();
					try2_US.show();
					try3.hide();
					try3_US.hide();	
					}
				}
				else if(rButtonDepth.isSelected()==true)
				{
					if (u==0)
					{
					desktopPane.add(try3);
					try1.hide();
					try1_US.hide();
					try2.hide();
					try2_US.hide();
					try3.show();
					try3_US.hide();
					}
					if(u==1)
					{
					desktopPane.add(try3_US);
					try1.hide();
					try1_US.hide();
					try2.hide();
					try2_US.hide();
					try3.hide();
					try3_US.show();	
					}
				}
				else
				{
					msj1 = new Notificacions();	
					JPanel Panel1 = new JPanel();
					JLabel lblNewLabel = new JLabel("SELECT AN OUTPUT!");
					lblNewLabel.setFont(new Font("Lucida Grande", Font.BOLD, 16));
					Panel1.add(lblNewLabel);
					msj1.getContentPane().add(Panel1);
					Panel1.setVisible(true);
					msj1.setVisible(true);
					msj1.setAlwaysOnTop(true);
	
				}
			}
		});
		
		btnForm.setFont(new Font("Lucida Grande", Font.BOLD, 15));
		
		btnCompute.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				btnNewButton.setVisible(true);
				
				
			}
		});
		btnCompute.setFont(new Font("Lucida Grande", Font.BOLD, 14));
		GroupLayout gl_panelCompute = new GroupLayout(panelCompute);
		gl_panelCompute.setHorizontalGroup(
			gl_panelCompute.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panelCompute.createSequentialGroup()
					.addContainerGap()
					.addComponent(btnForm)
					.addPreferredGap(ComponentPlacement.RELATED, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
					.addComponent(btnCompute)
					.addContainerGap())
		);
		gl_panelCompute.setVerticalGroup(
			gl_panelCompute.createParallelGroup(Alignment.LEADING)
				.addGroup(Alignment.TRAILING, gl_panelCompute.createSequentialGroup()
					.addContainerGap()
					.addGroup(gl_panelCompute.createParallelGroup(Alignment.TRAILING)
						.addComponent(btnCompute, Alignment.LEADING, GroupLayout.DEFAULT_SIZE, 52, Short.MAX_VALUE)
						.addComponent(btnForm, Alignment.LEADING, GroupLayout.DEFAULT_SIZE, 52, Short.MAX_VALUE))
					.addContainerGap())
		);
		panelCompute.setLayout(gl_panelCompute);
		panelCompute.setVisible(false);
		panelOutput.setLayout(null);
		
		
		JLabel label = new JLabel("Output:\n");
		label.setFont(new Font("Lucida Grande", Font.BOLD, 14));
		label.setBounds(16, 6, 59, 17);
		panelOutput.add(label);
		panelOutput.setVisible(false);
		
		buttonGroup.add(rButtonKick);
		rButtonKick.setFont(new Font("Lucida Grande", Font.PLAIN, 14));
		rButtonKick.setBounds(67, 30, 132, 23);
		panelOutput.add(rButtonKick);
		
		buttonGroup.add(rButtonMud);
		rButtonMud.setFont(new Font("Lucida Grande", Font.PLAIN, 14));
		rButtonMud.setBounds(199, 30, 121, 23);
		panelOutput.add(rButtonMud);
		
		buttonGroup.add(rButtonDepth);
		rButtonDepth.setFont(new Font("Lucida Grande", Font.PLAIN, 14));
		rButtonDepth.setBounds(322, 30, 151, 23);
		panelOutput.add(rButtonDepth);
		
		
		
		JLabel lblUnits = new JLabel("UNITS:");
		lblUnits.setFont(new Font("Lucida Grande", Font.PLAIN, 14));
		
		GroupLayout gl_panelUnits = new GroupLayout(panelUnits);
		gl_panelUnits.setHorizontalGroup(
			gl_panelUnits.createParallelGroup(Alignment.TRAILING)
				.addGroup(gl_panelUnits.createSequentialGroup()
					.addContainerGap()
					.addComponent(lblUnits, GroupLayout.DEFAULT_SIZE, 672, Short.MAX_VALUE)
					.addPreferredGap(ComponentPlacement.RELATED)
					.addComponent(cBoxUnits, GroupLayout.PREFERRED_SIZE, 101, GroupLayout.PREFERRED_SIZE)
					.addGap(5))
		);
		gl_panelUnits.setVerticalGroup(
			gl_panelUnits.createParallelGroup(Alignment.TRAILING)
				.addGroup(gl_panelUnits.createSequentialGroup()
					.addContainerGap(25, Short.MAX_VALUE)
					.addGroup(gl_panelUnits.createParallelGroup(Alignment.BASELINE)
						.addComponent(lblUnits)
						.addComponent(cBoxUnits, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(19))
		);
		panelUnits.setLayout(gl_panelUnits);
		panelUnits.setVisible(false);
		
		JButton btnFullWellAnalysis = new JButton("Full Well Analysis");
		btnFullWellAnalysis.setFont(new Font("Lucida Grande", Font.PLAIN, 14));
		
		btnSectionAnalysis = new JButton("Section Analysis");
		
		
		btnSectionAnalysis.setFont(new Font("Lucida Grande", Font.PLAIN, 14));
		GroupLayout gl_panelOptions = new GroupLayout(panelOptions);
		gl_panelOptions.setHorizontalGroup(
			gl_panelOptions.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panelOptions.createSequentialGroup()
					.addComponent(btnFullWellAnalysis)
					.addPreferredGap(ComponentPlacement.RELATED)
					.addComponent(btnSectionAnalysis, GroupLayout.PREFERRED_SIZE, 166, GroupLayout.PREFERRED_SIZE)
					.addContainerGap(44, Short.MAX_VALUE))
		);
		gl_panelOptions.setVerticalGroup(
			gl_panelOptions.createParallelGroup(Alignment.TRAILING)
				.addGroup(gl_panelOptions.createSequentialGroup()
					.addContainerGap(9, Short.MAX_VALUE)
					.addGroup(gl_panelOptions.createParallelGroup(Alignment.BASELINE)
						.addComponent(btnFullWellAnalysis, GroupLayout.PREFERRED_SIZE, 46, GroupLayout.PREFERRED_SIZE)
						.addComponent(btnSectionAnalysis, GroupLayout.PREFERRED_SIZE, 44, GroupLayout.PREFERRED_SIZE))
					.addContainerGap())
		);
		panelOptions.setLayout(gl_panelOptions);
		contentPane.setLayout(gl_contentPane);
		
		cBoxUnits.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {

						try1.setVisible(false);
						try1_US.setVisible(false);
						try2.setVisible(false);
						try2_US.setVisible(false);
						try3.setVisible(false);
						try3_US.setVisible(false);
						btnCompute.setVisible(false);
						btnNewButton.setVisible(false);
						
				
			}
		});
		
		btnNewButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				
				//n = cBoxUnits.getSelectedIndex();
				
				//if(rButtonKick.isSelected()== true)
				//{
					//if (n==0)
					//{
					panel.setVisible(false);
				

					//}
					//if(n==1)
					//{
					
					//}
				//}
	
				btnNewButton.setVisible(false);
			
			}
		});
	
		
}
			private void createEvents(){
			btnSectionAnalysis.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				panelOutput.setVisible(true);
				panelCompute.setVisible(true);
				panelUnits.setVisible(true);
				}
				});				
	}
			
			
}



